#ifndef INFECTUS_H
#define INFECTUS_H

#include <windef.h>

#ifdef INFECTUS_DLL_EXPORTS
#define INFECTUS_API __declspec(dllexport)
#else
#define INFECTUS_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define  I_HANDLE   void*
#define  I_DHANDLE  void*
#define  I_FHANDLE  void*

    INFECTUS_API I_HANDLE WINAPI  InfeUsbOpen( void );

    INFECTUS_API BOOL WINAPI InfeUsbClose( I_HANDLE iHandle);

    INFECTUS_API BOOL WINAPI InfeGetLastError( LPSTR Buffer , DWORD Size );

    INFECTUS_API BOOL WINAPI InfeUsbGetDLLVersion( LPDWORD h, LPDWORD l );
    INFECTUS_API BOOL WINAPI InfeUsbGetDriverVersion( LPDWORD h, LPDWORD l );

    INFECTUS_API BOOL WINAPI InfeUsbResetPLD( I_HANDLE iHandle );


    INFECTUS_API BOOL WINAPI InfeUsbReset( I_HANDLE iHandle );

    INFECTUS_API BOOL WINAPI InfeUsbGetPLDID( I_HANDLE iHandle, LPWORD lpdwPLDID );

    INFECTUS_API BOOL WINAPI InfeUsbDEVEnter( I_HANDLE iHandle, LPBYTE lpbCode );

    INFECTUS_API BOOL WINAPI InfeUsbDEVExit( I_HANDLE iHandle, LPBYTE lpbCode );

    INFECTUS_API BOOL WINAPI InfeUsbSelectFlash( I_HANDLE iHandle, BOOL Flash );

    INFECTUS_API BOOL WINAPI InfeUsbDeviceCount( LPDWORD lpdwDevCount );

    INFECTUS_API BOOL WINAPI InfeUsbGetPldStatus( I_HANDLE iHandle,
                                                  LPDWORD PldStatus );

    INFECTUS_API BOOL WINAPI GetFlashID( I_HANDLE iHandle, LPINT Productor, LPINT Device );

    INFECTUS_API BOOL WINAPI InfeUsbGetLoaderVersion( I_HANDLE iHandle, LPWORD Version );

    INFECTUS_API BOOL WINAPI InfeUsbSetTimeOut( I_HANDLE iHandle, DWORD Rx, DWORD Tx );

    //-------------------------------------------------------
    //-------------------------------------------------------
    //-------------------------------------------------------
    //-------------------------------------------------------

    INFECTUS_API I_DHANDLE WINAPI InfeDevCreate( void );
    INFECTUS_API BOOL WINAPI InfeDevDestroy( I_DHANDLE idHandle );
    INFECTUS_API BOOL WINAPI InfeDevIsSupported( I_DHANDLE idHandle, DWORD dwId, LPBOOL lpbRes );
    INFECTUS_API BOOL WINAPI InfeDevIsProdSupported( I_DHANDLE idHandle, DWORD dwId, LPBOOL lpbRes );
    INFECTUS_API BOOL WINAPI InfeDevGetFullName( I_DHANDLE idHandle, DWORD dwId, LPSTR lpszName, int MaxSize );
    INFECTUS_API BOOL WINAPI InfeDevGetProdName( I_DHANDLE idHandle, DWORD dwId, LPSTR lpszName, int MaxSize );
//    INFECTUS_API BOOL WINAPI InfeDevSetWVerify( I_DHANDLE idHandle, BOOL bVal );
    INFECTUS_API BOOL WINAPI InfeDevGetFlashID( I_DHANDLE idHandle, I_HANDLE iHandle, LPWORD lpwId );
    INFECTUS_API I_FHANDLE WINAPI InfeDevCreateFlash( I_DHANDLE idHandle, I_HANDLE iHandle, WORD wId );

    //-------------------------------------------------------
    //-------------------------------------------------------
    //-------------------------------------------------------
    //-------------------------------------------------------

    INFECTUS_API BOOL WINAPI InfeFlashBlank( I_FHANDLE idHandle, LPDWORD lpdwAddr );

    INFECTUS_API BOOL WINAPI InfeFlashEraseAll( I_FHANDLE idHandle );

    INFECTUS_API BOOL WINAPI InfeFlashEraseSector( I_FHANDLE idHandle, DWORD dwAddr );

    INFECTUS_API BOOL WINAPI InfeFlashReset( I_FHANDLE idHandle );

    INFECTUS_API BOOL WINAPI InfeFlashGetDeviceSize( I_FHANDLE idHandle, LPDWORD lpdwSize );

    INFECTUS_API BOOL WINAPI InfeFlashSetWVerify( I_FHANDLE idHandle, BOOL bVal );

    INFECTUS_API BOOL WINAPI InfeFlashRead( I_FHANDLE idHandle, DWORD dwAddr, LPSTR lpszBuffer, DWORD dwSize  );

    INFECTUS_API BOOL WINAPI InfeFlashWrite( I_FHANDLE idHandle, DWORD dwAddr,  LPSTR lpszBuffer, DWORD dwSize );

    //-------------------------------------------------------
    // POSTBUS
    //-------------------------------------------------------
    INFECTUS_API BOOL WINAPI InfeCounterStart( I_FHANDLE idHandle );
    INFECTUS_API BOOL WINAPI InfeCounterReset( I_FHANDLE idHandle );
    //INFECTUS_API BOOL WINAPI InfeCounterGet( I_FHANDLE idHandle, LPBOOL ret );
    INFECTUS_API BOOL WINAPI InfeCounterGet( I_FHANDLE ifHandle, LPBOOL ret, LPDWORD val, PTBYTE byte, LPBOOL overflow );

    //-------------------------------------------------------
    //-------------------------------------------------------
    //-------------------------------------------------------
    //-------------------------------------------------------

    typedef  I_HANDLE WINAPI (*PtrInfeUsbOpen)( void );
    typedef  BOOL WINAPI (*PtrInfeUsbClose)( I_HANDLE iHandle);
    typedef  BOOL WINAPI (*PtrInfeGetLastError)( LPSTR Buffer, DWORD Size );
    typedef  BOOL WINAPI (*PtrInfeUsbGetDLLVersion)( LPDWORD h, LPDWORD l );
    typedef  BOOL WINAPI (*PtrInfeUsbGetDriverVersion)( LPDWORD h, LPDWORD l );
    typedef  BOOL WINAPI (*PtrGetFlashID)( I_HANDLE iHandle, LPINT Productor, LPINT Device );
    typedef  BOOL WINAPI (*PtrInfeUsbGetLoaderVersion)( I_HANDLE iHandle, LPWORD Version );
    typedef  BOOL WINAPI (*PtrInfeUsbGetPldStatus)( I_HANDLE iHandle, LPDWORD PldStatus );
    typedef  BOOL WINAPI (*PtrInfeUsbGetPLDID)( I_HANDLE iHandle, LPWORD lpdwPLDID );
    typedef  BOOL WINAPI (*PtrInfeUsbResetPLD)( I_HANDLE iHandle );
    typedef  BOOL WINAPI (*PtrInfeUsbReset)( I_HANDLE iHandle );
    typedef  BOOL WINAPI (*PtrInfeUsbSetTimeOut)( I_HANDLE iHandle, DWORD Rx, DWORD Tx );
    typedef  BOOL WINAPI (*PtrInfeUsbDeviceCount)( LPDWORD lpdwDevCount );
    typedef  BOOL WINAPI (*PtrInfeUsbDEVEnter)( I_HANDLE iHandle, LPBYTE lpbCode );
    typedef  BOOL WINAPI (*PtrInfeUsbDEVExit)( I_HANDLE iHandle, LPBYTE lpbCode );
    typedef  BOOL WINAPI (*PtrInfeUsbSelectFlash)( I_HANDLE iHandle, BOOL Flash );

    typedef  I_DHANDLE WINAPI (*PtrInfeDevCreate)( void );
    typedef  I_DHANDLE WINAPI (*PtrInfeDevDestroy)( I_DHANDLE idHandle );
    typedef  BOOL WINAPI (*PtrInfeDevGetFlashID)( I_DHANDLE idHandle, I_HANDLE iHandle, LPWORD lpwId );
    typedef  BOOL WINAPI (*PtrInfeDevGetFullName)( I_DHANDLE idHandle, DWORD dwId, LPSTR lpszName, int MaxSize );
    typedef  BOOL WINAPI (*PtrInfeDevGetProdName)( I_DHANDLE idHandle, DWORD dwId, LPSTR lpszName, int MaxSize );
    typedef  BOOL WINAPI (*PtrInfeDevIsSupported)( I_DHANDLE idHandle, DWORD dwId, LPBOOL lpbRes );
    typedef  BOOL WINAPI (*PtrInfeDevIsProdSupported)( I_DHANDLE idHandle, DWORD dwId, LPBOOL lpbRes );
//    typedef  BOOL WINAPI (*PtrInfeDevSetWVerify)( I_DHANDLE idHandle, BOOL bVal );
    typedef  I_FHANDLE WINAPI (*PtrInfeDevCreateFlash)( I_DHANDLE idHandle, I_HANDLE iHandle, WORD wId );

    typedef  BOOL WINAPI (*PtrInfeFlashBlank)( I_FHANDLE ifHandle, LPDWORD lpdwAddr );
    typedef  BOOL WINAPI (*PtrInfeFlashEraseAll)( I_FHANDLE ifHandle );
    typedef  BOOL WINAPI (*PtrInfeFlashEraseSector)( I_FHANDLE ifHandle, DWORD dwAddr );
    typedef  BOOL WINAPI (*PtrInfeFlashReset)( I_FHANDLE ifHandle );
    typedef  BOOL WINAPI (*PtrInfeFlashGetDeviceSize)( I_FHANDLE ifHandle, LPDWORD lpdwSize );
    typedef  BOOL WINAPI (*PtrInfeFlashSetWVerify)( I_FHANDLE ifHandle, BOOL bVal );
    typedef  BOOL WINAPI (*PtrInfeFlashRead)( I_FHANDLE idHandle, DWORD dwAddr, LPSTR lpszBuffer, DWORD dwSize  );
    typedef  BOOL WINAPI (*PtrInfeFlashWrite)( I_FHANDLE idHandle, DWORD dwAddr,  LPSTR lpszBuffer, DWORD dwSize );


    //-------------------------------------------------------
    // POSTBUS
    //-------------------------------------------------------
    //typedef  BOOL WINAPI (*PtrInfeCounterGet)( I_FHANDLE ifHandle, LPBOOL ret, LPDWORD val, LPSTR byte, LPBOOL overflow );
    typedef  BOOL WINAPI (*PtrInfeCounterGet)( I_FHANDLE ifHandle, LPBOOL ret, LPDWORD val, PTBYTE byte, LPBOOL overflow );
    typedef  BOOL WINAPI (*PtrInfeCounterStart)( I_FHANDLE ifHandle );
    typedef  BOOL WINAPI (*PtrInfeCounterReset) ( I_FHANDLE ifHandle );

#ifdef __cplusplus
}
#endif
#endif


